include <library.scad>

module rectangle(units_x, units_y, add_support=true) {
	difference() {
		assert(units_x > 0);
		assert(units_y > 0);

		translate([-unit/2, -unit/2, -unit/2]) cube([grid*(units_x-1)+unit, grid*(units_y-1)+unit, unit]);

		// Cutout v-slots in x-negative and x-positive surfaces.
		for (y = [0:units_y-1]) translate([0, y*grid, 0]) {
			vslots_x_negative();
			translate([grid*(units_x-1), 0, 0]) vslots_x_positive();
		}

		// Cutout v-slots in y-negative and y-positive surfaces.
		for (x = [0:units_x-1]) translate([x*grid, 0, 0]) {
			vslots_y_negative();
			translate([0, grid*(units_y-1), 0]) vslots_y_positive();
		}

		// Cutout v-slots in z-negative and z-positive surfaces.
		for (x = [0:units_x-1]) for (y = [0:units_y-1]) translate([x*grid, y*grid, 0]) {
			vslots_z_negative();
			vslots_z_positive();
		}
	}

	if (add_support) support(units_x, units_y);
}

translate([0, 0, connector_height/2-unit/2]) connector();

translate([grid, 0, 0]) rectangle(1, 1);
translate([grid*2, 0, 0]) rectangle(1, 2);
translate([grid*3, 0, 0]) rectangle(1, 4);

translate([grid*5, 0, 0]) rectangle(1, 1);
translate([grid*6, 0, 0]) rectangle(2, 2);
translate([grid*8, 0, 0]) rectangle(4, 4);
