include <library.scad>

$fn = 64;

tolerance = 0.1;

module edge_flat() edge_using_profile() polygon([
	[-unit/2, unit/2],
	[unit/2, -unit/2],
	[-unit/2, -unit/2],
]);

module edge_round() edge_using_profile() translate([-unit/2, -unit/2]) intersection() {
	circle(unit);
	square(unit);
};

module edge_using_profile() {
	difference() {
		rotate(-90, [0, 1, 0]) linear_extrude(grid-tolerance*2, center=true) children();

		vslots_y_negative();
		vslots_z_negative();

		// Bevel edges of curved surface.
		rotate(-90) rotate(90, [1, 0, 0]) bevel();
		rotate(90, [0, 1, 0]) bevel();

		// Bevel edges of angular parts.
		// for (x = [0, 1]) mirror([x, 0, 0]) {
		// 	bevel();
		// 	rotate(90, [1, 0, 0]) bevel();
		// }
	}

	intersection() {
		translate([-grid, 0, 0]) support(3, 1);
		translate([0, -grid*0.6, 0]) cube(grid*1.2, center=true);
	}
}

// module corner_using_profile() {
// 	difference() {
// 		intersection() {
// 			linear_extrude(grid-tolerance*2, center=true) children();
// 			rotate(90, [1, 0, 0]) linear_extrude(grid-tolerance*2, center=true) children();
// 			rotate(-90, [0, 1, 0]) linear_extrude(grid-tolerance*2, center=true) children();
// 		}
// 
// 		vslots_x_negative();
// 		vslots_y_negative();
// 		vslots_z_negative();
// 	}
// 	
// 	intersection() {
// 		support(1, 1);
// 		linear_extrude(grid, center=true) polygon([
// 			[-unit/2-overlap, unit/2+overlap],
// 			[unit/2+overlap, -unit/2-overlap],
// 			[-unit/2-overlap, -unit/2-overlap],
// 		]);
// 	}
// }

// corner_using_profile() polygon([
// 	[-unit/2, unit/2],
// 	[unit/2, -unit/2],
// 	[-unit/2, -unit/2],
// ]);

edge_flat();
translate([grid, 0, 0]) edge_round();
